"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaymentController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const payment_schema_1 = require("../schemas/payment.schema");
const payment_service_1 = require("../services/payment.service");
let PaymentController = class PaymentController {
    constructor(paymentService) {
        this.paymentService = paymentService;
    }
    async create(payment) {
        try {
            return await this.paymentService.create(payment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(paymentId, updatedPayment) {
        try {
            return await this.paymentService.edit(paymentId, updatedPayment);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getById(paymentId) {
        try {
            return await this.paymentService.getById(paymentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByStudentId(studentId) {
        try {
            return await this.paymentService.getByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.paymentService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseIdAndStudentId(courseId, studentId) {
        try {
            return await this.paymentService.getByCourseIdAndStudentId(courseId, studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByEnrollmentsId(enrollmentsId) {
        try {
            return await this.paymentService.getByEnrollmentsId(enrollmentsId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(paymentId) {
        try {
            return await this.paymentService.delete(paymentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/payment.schema").Payment }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [payment_schema_1.Payment]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:paymentId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/payment.schema").Payment }),
    __param(0, (0, common_1.Param)('paymentId')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, payment_schema_1.Payment]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)('get-by-id:paymentId'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/payment.schema").Payment }),
    __param(0, (0, common_1.Param)('paymentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-student/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/payment.schema").Payment] }),
    __param(0, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "getByStudentId", null);
__decorate([
    (0, common_1.Get)('get-by-course/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/payment.schema").Payment] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Get)('get-by-course-and-student/:courseId/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/payment.schema").Payment] }),
    __param(0, (0, common_1.Param)('courseId')),
    __param(1, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "getByCourseIdAndStudentId", null);
__decorate([
    (0, common_1.Get)('get-by-enrollments/:enrollmentsId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/payment.schema").Payment] }),
    __param(0, (0, common_1.Param)('enrollmentsId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "getByEnrollmentsId", null);
__decorate([
    (0, common_1.Delete)('delete/:paymentId'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('paymentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], PaymentController.prototype, "delete", null);
PaymentController = __decorate([
    (0, swagger_1.ApiTags)("Payment"),
    (0, common_1.Controller)('payment'),
    __metadata("design:paramtypes", [payment_service_1.PaymentService])
], PaymentController);
exports.PaymentController = PaymentController;
//# sourceMappingURL=payment.controller.js.map