"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SectionController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const section_schema_1 = require("../schemas/section.schema");
const section_service_1 = require("../services/section.service");
let SectionController = class SectionController {
    constructor(sectionService) {
        this.sectionService = sectionService;
    }
    async create(section) {
        try {
            return await this.sectionService.create(section);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async edit(sectionId, updatedSection) {
        try {
            return await this.sectionService.edit(sectionId, updatedSection);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getAll() {
        try {
            return await this.sectionService.getAll();
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getById(sectionId) {
        try {
            return await this.sectionService.getById(sectionId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.NOT_FOUND);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.sectionService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getSectionByStatus(isActive) {
        try {
            return await this.sectionService.getSectionByStatus(isActive);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getSectionByCourseIdAndStatus(courseId, isActive) {
        try {
            return await this.sectionService.getSectionByCourseIdAndStatus(courseId, isActive);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async delete(sectionId) {
        try {
            return await this.sectionService.delete(sectionId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
};
__decorate([
    (0, common_1.Post)("create"),
    openapi.ApiResponse({ status: 201, type: [require("../schemas/section.schema").Section] }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Array]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "create", null);
__decorate([
    (0, common_1.Put)('edit/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/section.schema").Section }),
    __param(0, (0, common_1.Param)('id')),
    __param(1, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, section_schema_1.Section]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "edit", null);
__decorate([
    (0, common_1.Get)("get-all"),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/section.schema").Section] }),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "getAll", null);
__decorate([
    (0, common_1.Get)('get-by-id/:id'),
    openapi.ApiResponse({ status: 200, type: require("../schemas/section.schema").Section }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "getById", null);
__decorate([
    (0, common_1.Get)('get-by-course/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/section.schema").Section] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "getByCourseId", null);
__decorate([
    (0, common_1.Get)('get-by-status/:isActive'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/section.schema").Section] }),
    __param(0, (0, common_1.Param)('isActive')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Boolean]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "getSectionByStatus", null);
__decorate([
    (0, common_1.Get)('get-by-course-and-status/:courseId/:isActive'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/section.schema").Section] }),
    __param(0, (0, common_1.Param)('courseId')),
    __param(1, (0, common_1.Param)('isActive')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String, Boolean]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "getSectionByCourseIdAndStatus", null);
__decorate([
    (0, common_1.Delete)('delete/:id'),
    openapi.ApiResponse({ status: 200 }),
    __param(0, (0, common_1.Param)('id')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], SectionController.prototype, "delete", null);
SectionController = __decorate([
    (0, swagger_1.ApiTags)("Sections"),
    (0, common_1.Controller)('sections'),
    __metadata("design:paramtypes", [section_service_1.SectionService])
], SectionController);
exports.SectionController = SectionController;
//# sourceMappingURL=section.controller.js.map