"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StudentCoursesController = void 0;
const openapi = require("@nestjs/swagger");
const common_1 = require("@nestjs/common");
const swagger_1 = require("@nestjs/swagger");
const studentCourses_schema_1 = require("../schemas/studentCourses.schema");
const studentCourses_service_1 = require("../services/studentCourses.service");
let StudentCoursesController = class StudentCoursesController {
    constructor(studentCoursesService) {
        this.studentCoursesService = studentCoursesService;
    }
    async create(studentCourses) {
        try {
            return await this.studentCoursesService.create(studentCourses);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.BAD_REQUEST);
        }
    }
    async getByStudentId(studentId) {
        try {
            return await this.studentCoursesService.getByStudentId(studentId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
    async getByCourseId(courseId) {
        try {
            return await this.studentCoursesService.getByCourseId(courseId);
        }
        catch (error) {
            throw new common_1.HttpException(error.message, common_1.HttpStatus.INTERNAL_SERVER_ERROR);
        }
    }
};
__decorate([
    (0, common_1.Post)('create'),
    openapi.ApiResponse({ status: 201, type: require("../schemas/studentCourses.schema").StudentCourses }),
    __param(0, (0, common_1.Body)()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [studentCourses_schema_1.StudentCourses]),
    __metadata("design:returntype", Promise)
], StudentCoursesController.prototype, "create", null);
__decorate([
    (0, common_1.Get)('get-by-student/:studentId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/studentCourses.schema").StudentCourses] }),
    __param(0, (0, common_1.Param)('studentId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], StudentCoursesController.prototype, "getByStudentId", null);
__decorate([
    (0, common_1.Get)('get-by-course/:courseId'),
    openapi.ApiResponse({ status: 200, type: [require("../schemas/studentCourses.schema").StudentCourses] }),
    __param(0, (0, common_1.Param)('courseId')),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [String]),
    __metadata("design:returntype", Promise)
], StudentCoursesController.prototype, "getByCourseId", null);
StudentCoursesController = __decorate([
    (0, swagger_1.ApiTags)("StudentCourses"),
    (0, common_1.Controller)('student-courses'),
    __metadata("design:paramtypes", [studentCourses_service_1.StudentCoursesService])
], StudentCoursesController);
exports.StudentCoursesController = StudentCoursesController;
//# sourceMappingURL=studentCourses.controller.js.map