"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnrollmentsSchema = exports.Enrollments = void 0;
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const user_schema_1 = require("./user.schema");
const course_schema_1 = require("./course.schema");
let Enrollments = class Enrollments {
};
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "User", required: true }),
    __metadata("design:type", user_schema_1.User)
], Enrollments.prototype, "studentId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "studentName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "Course", required: true }),
    __metadata("design:type", course_schema_1.Course)
], Enrollments.prototype, "courseId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "courseName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ type: mongoose_2.default.Schema.Types.ObjectId, ref: "User", required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "instructorId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "organizationId", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "instructorName", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", String)
], Enrollments.prototype, "studentMobileNumber", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true }),
    __metadata("design:type", Number)
], Enrollments.prototype, "amount", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", String)
], Enrollments.prototype, "transactionType", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false }),
    __metadata("design:type", Boolean)
], Enrollments.prototype, "isAmountPaid", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, default: "Pending", enum: ["Pending", "Approved"] }),
    __metadata("design:type", String)
], Enrollments.prototype, "status", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, default: (0, mongoose_2.now)() }),
    __metadata("design:type", Date)
], Enrollments.prototype, "enrollmentDate", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: true, default: (0, mongoose_2.now)() }),
    __metadata("design:type", Date)
], Enrollments.prototype, "createdAt", void 0);
__decorate([
    (0, mongoose_1.Prop)({ required: false, default: (0, mongoose_2.now)() }),
    __metadata("design:type", Date)
], Enrollments.prototype, "updatedAt", void 0);
Enrollments = __decorate([
    (0, mongoose_1.Schema)({ timestamps: true })
], Enrollments);
exports.Enrollments = Enrollments;
exports.EnrollmentsSchema = mongoose_1.SchemaFactory.createForClass(Enrollments);
//# sourceMappingURL=enrollments.schema.js.map