import mongoose, { HydratedDocument } from "mongoose";
import { User } from "./user.schema";
import { Course } from "./course.schema";
import { Enrollments } from "./enrollments.schema";
export type PaymentDocument = HydratedDocument<Payment>;
export declare class Payment {
    studentId: User;
    studentName: string;
    courseId: Course;
    courseName: string;
    enrollmentsId: Enrollments;
    instructorId: User;
    organizationId: string;
    paymentDate: Date;
    amount: number;
    discountAmount: number;
    transactionType: string;
    transactionId: string;
    status: boolean;
    createdAt: Date;
    updatedAt: Date;
}
export declare const PaymentSchema: mongoose.Schema<Payment, mongoose.Model<Payment, any, any, any, mongoose.Document<unknown, any, Payment> & Payment & {
    _id: mongoose.Types.ObjectId;
}, any>, {}, {}, {}, {}, mongoose.DefaultSchemaOptions, Payment, mongoose.Document<unknown, {}, mongoose.FlatRecord<Payment>> & mongoose.FlatRecord<Payment> & {
    _id: mongoose.Types.ObjectId;
}>;
