import { Model } from 'mongoose';
import { Assignment, AssignmentDocument } from 'src/schemas/assignment.schema';
import { CloudinaryService } from './cloudinary.service';
export declare class AssignmentService {
    private assignmentModel;
    private readonly cloudinaryService;
    constructor(assignmentModel: Model<AssignmentDocument>, cloudinaryService: CloudinaryService);
    create(assignment: Assignment): Promise<Assignment>;
    edit(assignmentId: string, updatedAssignment: Assignment): Promise<Assignment>;
    findAll(): Promise<Assignment[]>;
    findById(assignmentId: string): Promise<Assignment>;
    findByLessonId(lessonId: string): Promise<Assignment[]>;
    delete(assignmentId: string): Promise<void>;
    deleteByLessonId(lessonId: string): Promise<void>;
    checkAssignmentTextNotExists(assignmentName: string, lessonId: any, excludedAssignmentId?: string): Promise<void>;
}
