import { Model } from "mongoose";
import { Category, CategoryDocument } from "src/schemas/category.schema";
export declare class CategoryService {
    private readonly categoryModel;
    constructor(categoryModel: Model<CategoryDocument>);
    create(category: Category): Promise<Category>;
    getAllCategories(): Promise<Category[]>;
    getAllCategoriesByStatus(status: boolean): Promise<Category[]>;
    getCategoryById(id: string): Promise<CategoryDocument>;
    update(id: string, updatedCategory: Category): Promise<Category>;
    delete(id: string): Promise<void>;
}
