import { CourseService } from './course.service';
import { SectionService } from './section.service';
import { LessonService } from './lesson.service';
import { QuestionService } from './question.service';
import { AssignmentService } from './assignment.service';
import { EnrollmentsService } from './enrollments.service';
import { UserService } from './user.service';
export declare class CourseDetailsService {
    private readonly courseService;
    private readonly sectionService;
    private readonly lessonService;
    private readonly questionService;
    private readonly assignmentService;
    private readonly enrollmentsService;
    private readonly userService;
    constructor(courseService: CourseService, sectionService: SectionService, lessonService: LessonService, questionService: QuestionService, assignmentService: AssignmentService, enrollmentsService: EnrollmentsService, userService: UserService);
    getCourseDetails(courseId: string): Promise<{
        id: any;
        courseName: any;
        organizationId: any;
        courseType: any;
        sections: {
            id: any;
            name: any;
            isActive: any;
            positions: any;
            duration: any;
            courseId: any;
            lessons: {
                id: any;
                name: any;
                sectionId: any;
                sectionName: any;
                duration: any;
                lessonURL: any;
                thumbnail: any;
                isFree: any;
                positions: any;
                isModelTest: any;
                passingMarks: any;
                examTime: any;
                isNegativeMarks: any;
                negativeMarks: any;
                isActive: any;
                info: any;
                questions: import("../schemas/question.schema").Question[];
                assignments: import("../schemas/assignment.schema").Assignment[];
            }[];
        }[];
    }>;
    getCourseWiseSection(courseId: string, studentId?: string | null): Promise<{
        id: any;
        courseName: any;
        isAuthUserCourse: boolean;
        organizationId: any;
        courseType: any;
        sections: {
            id: any;
            name: any;
            isActive: any;
            positions: any;
            duration: any;
            isAuthUserCourse: boolean;
            courseId: any;
            lessons: {
                id: any;
                name: any;
                duration: any;
                lessonURL: any;
                thumbnail: any;
                isFree: any;
                isAuthUser: boolean;
                positions: any;
                isModelTest: any;
                isActive: any;
            }[];
        }[];
    }>;
    getLessonDetails(lessonId: string): Promise<{
        id: any;
        name: string;
        sectionId: import("../schemas/section.schema").Section;
        sectionName: string;
        duration: string;
        lessonURL: string;
        thumbnail: string;
        isFree: boolean;
        positions: number;
        isModelTest: boolean;
        passingMarks: number;
        examTime: number;
        isNegativeMarks: boolean;
        negativeMarks: number;
        markPerQuestion: number;
        isActive: boolean;
        info: string;
        questions: import("../schemas/question.schema").Question[];
        assignments: import("../schemas/assignment.schema").Assignment[];
    }>;
    deleteLessonWithQuestionsAssignment(lessonId: string): Promise<void>;
    getCoursesSummary(courseType: string): Promise<any>;
}
