import { Model } from 'mongoose';
import { CourseProgress, CourseProgressDocument } from 'src/schemas/courseProgress.schema';
export declare class CourseProgressService {
    private courseProgressModel;
    constructor(courseProgressModel: Model<CourseProgressDocument>);
    create(courseProgress: CourseProgress): Promise<CourseProgress>;
    edit(courseProgressId: string, updatedCourseProgress: CourseProgress): Promise<CourseProgress>;
    getById(courseProgressId: string): Promise<CourseProgress>;
    getByStudentId(studentId: string): Promise<CourseProgress[]>;
    getByCourseId(courseId: string): Promise<CourseProgress[]>;
    getByLessonId(lessonId: string): Promise<CourseProgress[]>;
    delete(courseProgressId: string): Promise<void>;
}
