import { Model } from "mongoose";
import { Enrollments, EnrollmentsDocument } from "src/schemas/enrollments.schema";
import { StudentCoursesService } from "./studentCourses.service";
import { PaymentService } from "./payment.service";
import { PaymentDocument } from "src/schemas/payment.schema";
import { StudentCoursesDocument } from "src/schemas/studentCourses.schema";
export declare class EnrollmentsService {
    private enrollmentsModel;
    private readonly studentCoursesService;
    private readonly paymentService;
    private paymentModel;
    private studentCoursesModel;
    constructor(enrollmentsModel: Model<EnrollmentsDocument>, studentCoursesService: StudentCoursesService, paymentService: PaymentService, paymentModel: Model<PaymentDocument>, studentCoursesModel: Model<StudentCoursesDocument>);
    create(enrollment: any): Promise<Enrollments>;
    edit(enrollmentId: string, updatedEnrollment: any): Promise<Enrollments>;
    getAllEnrollments(): Promise<any[]>;
    private populateEnrollment;
    getAllDetailsByEnrollmentId(enrollmentId: string): Promise<any>;
    getById(enrollmentId: string): Promise<Enrollments>;
    getByStudentId(studentId: string): Promise<Enrollments[]>;
    getByCourseId(courseId: string): Promise<Enrollments[]>;
    getByInstructorId(instructorId: string): Promise<Enrollments[]>;
    getByStudentAndCourseId(courseId: string, studentId: string): Promise<Enrollments>;
    delete(enrollmentId: string): Promise<void>;
    getTotalEnrolments(): Promise<number>;
}
