"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PetService = void 0;
const common_1 = require("@nestjs/common");
const mongoose_1 = require("@nestjs/mongoose");
const mongoose_2 = require("mongoose");
const pet_schema_1 = require("../schemas/pet.schema");
let PetService = class PetService {
    constructor(petModel) {
        this.petModel = petModel;
    }
    async findAll() {
        return this.petModel.find().exec();
    }
    async findById(id) {
        return this.petModel.findById(id).exec();
    }
    async create(pet) {
        const createdPet = new this.petModel(pet);
        return createdPet.save();
    }
    async update(id, pet) {
        await this.petModel.findByIdAndUpdate(id, pet);
        return this.petModel.findById(id).exec();
    }
    async delete(id) {
        const deletedPet = await this.petModel.findById(id).exec();
        await this.petModel.findByIdAndDelete(id).exec();
        return deletedPet;
    }
    async findAllDog() {
        return this.petModel.find({ petType: '64ecb73ed3988b6470ea3687' }).exec();
    }
    async findAllCat() {
        return this.petModel.find({ petType: '64ec9c3a0b80aac7042c8802' }).exec();
    }
    async findAllBird() {
        return this.petModel.find({ petType: '64ef2bdf577ab6435f7cfb1a' }).exec();
    }
    async findAllReptile() {
        return this.petModel.find({ petType: '64ef2be7577ab6435f7cfb1c' }).exec();
    }
    async loveReaction(id) {
        const pet = await this.petModel.findById(id).exec();
        pet.loveCount = pet.loveCount + 1;
        return pet.save();
    }
};
PetService = __decorate([
    (0, common_1.Injectable)(),
    __param(0, (0, mongoose_1.InjectModel)(pet_schema_1.Pet.name)),
    __metadata("design:paramtypes", [mongoose_2.Model])
], PetService);
exports.PetService = PetService;
//# sourceMappingURL=pet.service.js.map