import { Model } from 'mongoose';
import { QuestionMarks, QuestionMarksDocument } from 'src/schemas/questionMarks.schema';
import { CloudinaryService } from './cloudinary.service';
export declare class QuestionMarksService {
    private questionMarksModel;
    private readonly cloudinaryService;
    constructor(questionMarksModel: Model<QuestionMarksDocument>, cloudinaryService: CloudinaryService);
    create(questionMarks: QuestionMarks): Promise<QuestionMarks>;
    edit(questionMarksId: string, updatedQuestionMarks: QuestionMarks): Promise<QuestionMarks>;
    getById(questionMarksId: string): Promise<QuestionMarks>;
    getByStudentId(studentId: string): Promise<QuestionMarks[]>;
    getByStudentAndCourseId(courseId: string, studentId: string): Promise<QuestionMarks[]>;
    getByStudentAndLessonId(lessonId: string, studentId: string): Promise<QuestionMarks[]>;
    getByTo10Students(courseId: string): Promise<any[]>;
    getDetailsQuestionMarksByStudentId(studentId: string): Promise<any[]>;
    delete(questionMarksId: string): Promise<void>;
}
